Bug 657646 - pidof is broken on FC14
Summary: pidof is broken on FC14
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: sysvinit
Version: 14
Hardware: x86_64
OS: Linux
low
low
Target Milestone: ---
Assignee: Petr Lautrbach
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-11-27 00:00 UTC by Andrew Wasielewski
Modified: 2010-12-02 19:13 UTC (History)
3 users (show)

Fixed In Version: sysvinit-2.87-6.dsf.fc14
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-12-02 19:13:01 UTC


Attachments (Terms of Use)
fixed sysvinit-2.87-omit.patch (4.77 KB, patch)
2010-11-29 13:05 UTC, Petr Lautrbach
no flags Details | Diff

Description Andrew Wasielewski 2010-11-27 00:00:30 UTC
Description of problem: Since upgrade to FC14 I get an error when I try to stop or query status of some (but not all) services. Services affected include LCDd and bacula-sd (initially I thought this was a Bacula issue). When I query the status or stop bacula-sd - but not when I (re)start it - I get the following output & syslog messages referencing libc-2.12.90.so:

root@localhost init.d]# ./bacula-sd status
bacula-sd dead but subsys locked

Nov  8 21:24:47 localhost kernel: [161155.229044] pidof[17514]: segfault at 0 ip 00007f2f9097d316 sp 00007fffb83e2888 error 4 in libc-2.12.90.so[7f2f908fc000+199000]
Nov  8 21:24:47 localhost kernel: [161155.271610] pidof[17515]: segfault at 0 ip 00007f8835f08316 sp 00007fff931ff828 error 4 in libc-2.12.90.so[7f8835e87000+199000]

Affected services cannot be stopped from command line but have to be killed, and display in system-config-services does not update properly.

Version-Release number of selected component (if applicable):
Kernel 2.6.35.6-48.fc14.x86_64
Glibc on ver. 2.12.90-18 when problem emerged, now on 2.12.90-19 but still persists


How reproducible:
Query service status e.g. [root@localhost init.d]# ./bacula-sd status


Steps to Reproduce:
1.
2.
3.
  
Actual results:
Command line output "bacula-sd dead but subsys locked"


Expected results:
Expect something like:
[root@localhost init.d]# ./clamav status
clamd (pid 1949) is running...


Additional info:
See posting & discussion on Backup Central:- http://www.backupcentral.com/phpBB2/two-way-mirrors-of-external-mailing-lists-3/bacula-25/problem-with-bacula-sd-on-fedora-14-maybe-glibc-related-108925/?sid=80a62f44218ab98f0eba872155c63c52

Comment 1 Petr Lautrbach 2010-11-29 12:23:59 UTC
There is bad usage of canonicalize_file_name() in function matches() in src/killall5.c introduced by sysvinit-2.87-omit.patch.

It works if absolute path or /sbin/service are used:

# /etc/init.d/bacula-sd status
bacula-sd (pid 1994) is running...

# service bacula-sd status
bacula-sd (pid 1994) is running...

# ./bacula-sd status
bacula-sd dead but subsys locked

Comment 2 Petr Lautrbach 2010-11-29 13:05:26 UTC
Created attachment 463479 [details]
fixed sysvinit-2.87-omit.patch

reworked matches() - if canonicalize_file_name() returns NULL then use copy of argument.

# ./bacula-sd status
bacula-sd (pid 1994) is running...

# service bacula-sd status
bacula-sd (pid 1994) is running...

# /etc/init.d/bacula-sd status
bacula-sd (pid 1994) is running...

Comment 3 Fedora Update System 2010-11-29 13:29:42 UTC
sysvinit-2.87-6.dsf.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/sysvinit-2.87-6.dsf.fc14

Comment 4 Fedora Update System 2010-11-29 21:35:44 UTC
sysvinit-2.87-6.dsf.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update sysvinit'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/sysvinit-2.87-6.dsf.fc14

Comment 5 Fedora Update System 2010-12-02 19:12:56 UTC
sysvinit-2.87-6.dsf.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.